sub duplo_ui_ui_ui()
 REM		$Id$
 REM	Copyright (c) New Deal 1997 -- All Rights Reserved
 REM	FILE:		STDINC.BH

 STRUCT TimeOfDay
  DIM hour as integer
  DIM minute as integer
  DIM second as integer
 END STRUCT

 STRUCT Date
  DIM year as integer
  DIM month as integer
  DIM day as integer
 END STRUCT

 STRUCT Notification
  DIM arg1 as integer
  DIM arg2 as integer
  DIM arg3 as integer
  DIM arg4 as integer
  DIM arg5 as string
  DIM arg6 as complex
 END STRUCT

REM useful color constants
CONST WHITE 		&Hffffffff
CONST BLACK 		&Hff000000
CONST GRAY_50 		&Hff808080, GREY_50 		&Hff808080
CONST DARK_GRAY 	&Hff555555, LIGHT_GRAY		&Hffaaaaaa
CONST DARK_GREY 	&Hff555555, LIGHT_GREY		&Hffaaaaaa
CONST DARK_GREEN	&Hff00aa00, LIGHT_GREEN 	&Hff55ff55
CONST DARK_BLUE 	&Hff0000aa, LIGHT_BLUE		&Hff5555ff
CONST DARK_CYAN		&Hff00aaaa, LIGHT_CYAN		&Hff55ffff
CONST DARK_PURPLE	&Hffaa00aa, LIGHT_PURPLE	&Hffff55ff
CONST DARK_RED		&Hffaa0000, LIGHT_RED		&Hffff5555
CONST BROWN		&Hffaa5500, YELLOW		&Hffffff55

REM useful text style constants
CONST UNDERLINE		1
CONST STRIKE_THRU	2
CONST SUBSCRIPT		4
CONST SUPERSCRIPT	8
CONST ITALIC		16
CONST BOLD		32

REM useful Boolean constants
CONST TRUE		1
CONST FALSE		0

REM sound constants
CONST SS_ERROR		0
CONST SS_WARNING	1
CONST SS_NOTIFY		2
CONST SS_NO_INPUT	3
CONST SS_KEY_CLICK	4
CONST SS_ALARM		5

CONST MOUSE_PRESS 1, MOUSE_HOLD 2, MOUSE_DRAG 3, MOUSE_TO 4, MOUSE_RELEASE 5
CONST MOUSE_LOST 6, MOUSE_FLY_OVER 7

CONST C_SYS_00			&Hff00
CONST C_SYS_FF			&Hffff
CONST C_SYS_BACKSPACE		&Hff08
CONST C_SYS_TAB			&Hff09
CONST C_SYS_ENTER		&Hff0d
CONST C_SYS_ESCAPE		&Hff1b
CONST C_SYS_F1			&Hff80
CONST C_SYS_F2			&Hff81
CONST C_SYS_F3			&Hff82
CONST C_SYS_F4			&Hff83
CONST C_SYS_F5			&Hff84
CONST C_SYS_F6			&Hff85
CONST C_SYS_F7			&Hff86
CONST C_SYS_F8			&Hff87
CONST C_SYS_F9			&Hff88
CONST C_SYS_F10			&Hff89
CONST C_SYS_F11			&Hff8a
CONST C_SYS_F12			&Hff8b
CONST C_SYS_F13			&Hff8c
CONST C_SYS_F14			&Hff8d
CONST C_SYS_F15			&Hff8e
CONST C_SYS_F16			&Hff8f
CONST C_SYS_UP			&Hff90
CONST C_SYS_DOWN		&Hff91
CONST C_SYS_RIGHT		&Hff92
CONST C_SYS_LEFT		&Hff93
CONST C_SYS_HOME		&Hff94
CONST C_SYS_END			&Hff95
CONST C_SYS_PREVIOUS		&Hff96
CONST C_SYS_NEXT		&Hff97
CONST C_SYS_INSERT		&Hff98
CONST C_SYS_CLEAR		&Hff99	rem Not used in Geos.
CONST C_SYS_DELETE		&Hff9a
CONST C_SYS_PRINT_SCREEN	&Hff9b
CONST C_SYS_HELP		&Hff9d	rem Not used in Geos.
CONST C_SYS_BREAK		&Hff9e
CONST C_SYS_CAPS_LOCK		&Hffe8
CONST C_SYS_NUM_LOCK		&Hffe9
CONST C_SYS_SCROLL_LOCK		&Hffea
CONST C_SYS_LEFT_ALT		&Hffe0
CONST C_SYS_RIGHT_ALT		&Hffe1
CONST C_SYS_LEFT_CTRL		&Hffe2
CONST C_SYS_RIGHT_CTRL		&Hffe3
CONST C_SYS_LEFT_SHIFT		&Hffe4
CONST C_SYS_RIGHT_SHIFT		&Hffe5


CONST KEY_BS 		&Hff08
CONST KEY_DEL 		&Hff9a
CONST KEY_ENTER 	&Hff0d
CONST KEY_KP_RETURN 	&Hffff
CONST KEY_HOME		&Hff94
CONST KEY_TAB		&Hff09
CONST KEY_END		&Hff93
CONST KEY_ESC		&Hff1b
CONST KEY_UP_ARROW	&Hff90
CONST KEY_LEFT_ARROW	&Hff93
CONST KEY_RIGHT_ARROW	&Hff92
CONST KEY_DOWN_ARROW	&Hff91

REM date formats
CONST DTF_LONG				0
CONST DTF_LONG_CONDENSED		1
CONST DTF_LONG_NO_WEEKDAY		2
CONST DTF_LONG_NO_WEEKDAY_CONDENSED	3
CONST DTF_SHORT				4
CONST DTF_ZERO_PADDED_SHORT		5
CONST DTF_MD_LONG			6
CONST DTF_MD_LONG_NO_WEEKDAY		7
CONST DTF_MD_SHORT			8
CONST DTF_MY_LONG			9
CONST DTF_MY_SHORT			10
CONST DTF_YEAR				11
CONST DTF_MONTH				12
CONST DTF_DAY				13
CONST DTF_WEEKDAY			14
REM time formats
CONST DTF_HMS				15
CONST DTF_HM				16
CONST DTF_H				17
CONST DTF_MS				18
CONST DTF_HMS_24HOUR			19
CONST DTF_HM_24HOUR			20

REM pi
CONST PI 3.14159265359

REM Format() constants
CONST FFAF_SCIENTIFIC		&H100
CONST FFAF_PERCENT		&H80
CONST FFAF_USE_COMMAS		&H40
CONST FFAF_NO_TRAIL_ZEROS	&H20
CONST FFAF_NO_LEAD_ZERO		&H10

REM dim system as module
REM system = SystemModule()

 REM end of stdinc.bh

DisableEvents()
Dim formMetronome as form
formMetronome = MakeComponent("form","app")
CompInit formMetronome
proto="formMetronome"
top=216
left=373
tile=1
caption="Metronome"
tileSpacing=4
End CompInit
Dim gadgetMetronome as gadget
gadgetMetronome = MakeComponent("gadget",formMetronome)
CompInit gadgetMetronome
proto="gadgetMetronome"
width=320
height=100
visible=1
End CompInit
gadgetMetronome.name="gadgetMetronome"
Dim groupEntry as group
groupEntry = MakeComponent("group",formMetronome)
CompInit groupEntry
proto="groupEntry"
caption=""
look=1
sizeHControl=2
sizeVControl=3
tile=1
tileSpacing=4
visible=1
End CompInit
Dim groupSpeed as group
groupSpeed = MakeComponent("group",groupEntry)
CompInit groupSpeed
proto="groupSpeed"
caption=""
sizeVControl=3
tile=1
tileHAlign=2
tileLayout=1
tileSpacing=4
sizeHControl=2
look=2
visible=1
End CompInit
Dim labelSpeed as label
labelSpeed = MakeComponent("label",groupSpeed)
CompInit labelSpeed
proto="labelSpeed"
caption="Speed"
sizeHControl=0
sizeVControl=3
width=60
visible=1
End CompInit
labelSpeed.name="labelSpeed"
Dim listSpeed as list
listSpeed = MakeComponent("list",groupSpeed)
CompInit listSpeed
proto="listSpeed"
width=60
sizeVControl=3
End CompInit
listSpeed.name="listSpeed"
listSpeed.captions[7]="Prestissimo"
listSpeed.captions[6]="Presto"
listSpeed.captions[5]="Allegro"
listSpeed.captions[4]="Moderato"
listSpeed.captions[3]="Andante"
listSpeed.captions[2]="Adagio"
listSpeed.captions[1]="Larghetio"
listSpeed.captions[0]="Largo"
listSpeed.visible=1
listSpeed.selectedItem=0
Dim numberSpeed as number
numberSpeed = MakeComponent("number",groupSpeed)
CompInit numberSpeed
proto="numberSpeed"
caption=""
value=42
minimum=42
maximum=208
displayFormat=0
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
numberSpeed.name="numberSpeed"
groupSpeed.name="groupSpeed"
Dim groupMeasure as group
groupMeasure = MakeComponent("group",groupEntry)
CompInit groupMeasure
proto="groupMeasure"
caption=""
sizeVControl=3
tile=1
tileHAlign=2
tileLayout=1
tileSpacing=4
sizeHControl=2
look=2
visible=1
End CompInit
Dim labelMeasure as label
labelMeasure = MakeComponent("label",groupMeasure)
CompInit labelMeasure
proto="labelMeasure"
caption="Measure"
sizeHControl=0
sizeVControl=3
width=60
visible=1
End CompInit
labelMeasure.name="labelMeasure"
Dim listMeasure as list
listMeasure = MakeComponent("list",groupMeasure)
CompInit listMeasure
proto="listMeasure"
width=60
sizeVControl=3
End CompInit
listMeasure.name="listMeasure"
listMeasure.captions[6]="8/16"
listMeasure.captions[5]="8/8"
listMeasure.captions[4]="4/8"
listMeasure.captions[3]="3/8"
listMeasure.captions[2]="4/4"
listMeasure.captions[1]="3/4"
listMeasure.captions[0]="User defined"
listMeasure.visible=1
listMeasure.selectedItem=2
Dim numberMeasure1 as number
numberMeasure1 = MakeComponent("number",groupMeasure)
CompInit numberMeasure1
proto="numberMeasure1"
caption=""
value=4
minimum=1
maximum=8
displayFormat=0
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
numberMeasure1.name="numberMeasure1"
Dim labelMeasureDelemiter as label
labelMeasureDelemiter = MakeComponent("label",groupMeasure)
CompInit labelMeasureDelemiter
proto="labelMeasureDelemiter"
caption="/"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
labelMeasureDelemiter.name="labelMeasureDelemiter"
Dim numberMeasure2 as number
numberMeasure2 = MakeComponent("number",groupMeasure)
CompInit numberMeasure2
proto="numberMeasure2"
caption=""
value=4
minimum=1
maximum=16
sizeHControl=3
sizeVControl=3
displayFormat=0
visible=1
End CompInit
numberMeasure2.name="numberMeasure2"
groupMeasure.name="groupMeasure"
groupEntry.name="groupEntry"
Dim groupControl as group
groupControl = MakeComponent("group",formMetronome)
CompInit groupControl
proto="groupControl"
caption=""
sizeVControl=3
tile=1
tileLayout=1
tileSpacing=4
sizeHControl=2
tileHAlign=2
look=1
visible=1
End CompInit
Dim labelControl as label
labelControl = MakeComponent("label",groupControl)
CompInit labelControl
proto="labelControl"
caption="Control"
sizeHControl=0
sizeVControl=3
width=60
visible=1
End CompInit
labelControl.name="labelControl"
Dim buttonStart as button
buttonStart = MakeComponent("button",groupControl)
CompInit buttonStart
proto="buttonStart"
caption="Start"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
buttonStart.name="buttonStart"
Dim buttonStop as button
buttonStop = MakeComponent("button",groupControl)
CompInit buttonStop
proto="buttonStop"
caption="Stop"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
buttonStop.name="buttonStop"
Dim buttonReset as button
buttonReset = MakeComponent("button",groupControl)
CompInit buttonReset
proto="buttonReset"
caption="Reset"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
buttonReset.name="buttonReset"
groupControl.name="groupControl"
formMetronome.name="formMetronome"
formMetronome.height=228
formMetronome.width=338
Dim timerMetronome as timer
timerMetronome = MakeComponent("timer","app")
CompInit timerMetronome
proto="timerMetronome"
interval=1
End CompInit
timerMetronome.name="timerMetronome"
Dim soundMetronome as sound
soundMetronome = MakeComponent("sound","app")
CompInit soundMetronome
proto="soundMetronome"
End CompInit
soundMetronome.name="soundMetronome"
EnableEvents()
duplo_start()
end sub

sub duplo_start()
  const TIMER_TICKS_PER_MINUTE 3600

  const BEATS_PER_MINUTE_LARGO 42
  const BEATS_PER_MINUTE_LARGETHIO 60
  const BEATS_PER_MINUTE_ADAGIO 72
  const BEATS_PER_MINUTE_ANDANTE 92
  const BEATS_PER_MINUTE_MODERATO 116
  const BEATS_PER_MINUTE_ALLEGRO 144
  const BEATS_PER_MINUTE_PRESTO 184
  const BEATS_PER_MINUTE_PRESTISSIMO 200

  const GADGET_METRONOME_INDENT 4
  const GADGET_METRONOME_TEXT_HEIGHT 16
  const GADGET_METRONOME_TEXT_WIDTH 150

  const GADGET_METRONOME_DIGITAL_INDICATOR_Y 20
  const GADGET_METRONOME_DIGITAL_INDICATOR_MAX_DIVISIONS 32

  dim x1 as integer
  dim y1 as integer
  dim y2 as integer

  dim statusMsg as string

  dim measure_count as long

  dim beats_per_minute as integer				'[42..208]
  dim beats_per_measure as integer				'[1..16]
  dim beat_of_measure as integer

  dim divisions_per_measure as integer
  dim divisions_per_beat as integer			'[1..16]
  dim division_of_beat as integer

  dim timer_ticks_per_division as integer	'[21..4]
  dim timer_tick_of_division as integer

  dim pixels_per_beat as integer
  dim pixels_per_division as integer

  dim beats_per_line as integer
  dim beat_of_line as integer
  dim lines_per_measure as integer
  dim line_of_measure as integer

  beats_per_minute = numberSpeed.value
  beats_per_measure = numberMeasure1.value
  divisions_per_beat = numberMeasure2.value

  metronome_reset()
  metronome_init()
end sub

sub module_goTo(context as string)

end sub

function module_getContext()
  module_getContext = ""
end function

sub module_show()
  REM code for making this module appear
  formMetronome.visible=1
end sub

sub module_hide()
  REM code for making this module disappear
  formMetronome.visible=0
end sub

sub module_exit()
  if (timerMetronome.enabled = TRUE) then
    timerMetronome.enabled = FALSE
  end if
end sub

sub gadgetMetronome_draw(self as gadget)
  gadgetMetronome_drawStatus(self)

  y1 = GADGET_METRONOME_TEXT_HEIGHT
  y2 = self.height - GADGET_METRONOME_TEXT_HEIGHT
  self.DrawRect(0, y1, self.width, y2, BLACK)

  y1 = self.height - GADGET_METRONOME_TEXT_HEIGHT
  y2 = self.height
  self.DrawRect(0, y1, GADGET_METRONOME_TEXT_WIDTH, y2, DARK_GRAY)
  self.DrawText("Measure count:", GADGET_METRONOME_INDENT, y1 + 1, WHITE, "", 11, 0)
  gadgetMetronome_drawMeasureCounter(self)

end sub

sub gadgetMetronome_drawStatus(self as gadget)
  self.DrawRect(0, 0, self.width, GADGET_METRONOME_TEXT_HEIGHT, DARK_GRAY)
  self.DrawText(statusMsg, GADGET_METRONOME_INDENT, 1, WHITE, "", 11, 0)
end sub

sub gadgetMetronome_drawMeasureCounter(self as gadget)
  y1 = self.height - GADGET_METRONOME_TEXT_HEIGHT
  y2 = self.height
  self.DrawRect(GADGET_METRONOME_TEXT_WIDTH, y1, self.width, y2, DARK_GRAY)
  self.DrawText(Str(measure_count + 1), GADGET_METRONOME_TEXT_WIDTH, y1 + 1, WHITE, "", 11, 0)
end sub

sub gadgetMetronome_drawDigitalIndicator(self as gadget)
  dim i as integer
  i = beat_of_measure mod beats_per_line
  x1 = GADGET_METRONOME_INDENT + pixels_per_beat * i
  line_of_measure = beat_of_measure / beats_per_line
  y1 = GADGET_METRONOME_DIGITAL_INDICATOR_Y + GADGET_METRONOME_TEXT_HEIGHT * line_of_measure
  if (division_of_beat = 0) then
    if (beat_of_measure = 0) then
      self.DrawRect(0, GADGET_METRONOME_DIGITAL_INDICATOR_Y, self.width, self.height - GADGET_METRONOME_TEXT_HEIGHT, BLACK)
    end if
    self.DrawText(Str(beat_of_measure + 1), x1, y1, LIGHT_BLUE, "", 10, 0)
  else
    x1 = x1 + pixels_per_division * division_of_beat
    self.DrawText("+", x1, y1, LIGHT_BLUE, "", 10, 0)
  end if
end sub

sub metronome_init()
  timer_ticks_per_division = TIMER_TICKS_PER_MINUTE / beats_per_minute / divisions_per_beat
  divisions_per_measure = beats_per_measure * divisions_per_beat

  if (GADGET_METRONOME_DIGITAL_INDICATOR_MAX_DIVISIONS > divisions_per_measure)
    beats_per_line = beats_per_measure
    lines_per_measure = 1
  else
    beats_per_line = GADGET_METRONOME_DIGITAL_INDICATOR_MAX_DIVISIONS / divisions_per_beat
    if (beats_per_line = 0) then
      beats_per_line = 1
    end if
    lines_per_measure = divisions_per_measure / (beats_per_line * divisions_per_beat)
    if (lines_per_measure = 0) then
      lines_per_measure = 1
    end if
  end if

  x1 = gadgetMetronome.width - 2 * GADGET_METRONOME_INDENT
  pixels_per_beat = x1 / beats_per_line
  pixels_per_division = pixels_per_beat / divisions_per_beat
end sub

sub metronome_reset()
  statusMsg = "Ready..."
  measure_count = 0
  beat_of_measure = 0
  division_of_beat = 0
  timer_tick_of_division = 0
  beat_of_line = 1
  line_of_measure = 1
end sub

sub buttonStart_pressed(self as button)
  timerMetronome.enabled = TRUE
  statusMsg = "Started..."
  gadgetMetronome_drawStatus(gadgetMetronome)
end sub

sub buttonStop_pressed(self as button)
  timerMetronome.enabled = FALSE
  statusMsg = "Stopped..."
  gadgetMetronome_drawStatus(gadgetMetronome)
end sub

sub buttonReset_pressed(self as button)
  timerMetronome.enabled = FALSE
  metronome_reset()
  gadgetMetronome_draw(gadgetMetronome)
  gadgetMetronome_drawStatus(gadgetMetronome)
  gadgetMetronome_drawMeasureCounter(gadgetMetronome)
end sub

sub listSpeed_changed(self as list, index as integer)
  select case index
    case 0
      beats_per_minute = BEATS_PER_MINUTE_LARGO
    case 1
      beats_per_minute = BEATS_PER_MINUTE_LARGETHIO
    case 2
      beats_per_minute = BEATS_PER_MINUTE_ADAGIO
    case 3
      beats_per_minute = BEATS_PER_MINUTE_ANDANTE
    case 4
      beats_per_minute = BEATS_PER_MINUTE_MODERATO
    case 5
      beats_per_minute = BEATS_PER_MINUTE_ALLEGRO
    case 6
      beats_per_minute = BEATS_PER_MINUTE_PRESTO
    case 7
      beats_per_minute = BEATS_PER_MINUTE_PRESTISSIMO
  end select
  numberSpeed.value = beats_per_minute
  metronome_init()
end sub

sub numberSpeed_changed(self as number, value as integer)
  if (value < BEATS_PER_MINUTE_LARGETHIO) then
    listSpeed.selectedItem = 0
  else if (value >= BEATS_PER_MINUTE_LARGETHIO and value < BEATS_PER_MINUTE_ADAGIO) then
    listSpeed.selectedItem = 1
  else if (value >= BEATS_PER_MINUTE_ADAGIO and value < BEATS_PER_MINUTE_ANDANTE) then
    listSpeed.selectedItem = 2
  else if (value >= BEATS_PER_MINUTE_ANDANTE and value < BEATS_PER_MINUTE_MODERATO) then
    listSpeed.selectedItem = 3
  else if (value >= BEATS_PER_MINUTE_MODERATO and value < BEATS_PER_MINUTE_ALLEGRO) then
    listSpeed.selectedItem = 4
  else if (value >= BEATS_PER_MINUTE_ALLEGRO and value < BEATS_PER_MINUTE_PRESTO) then
    listSpeed.selectedItem = 5
  else if (value >= BEATS_PER_MINUTE_PRESTO and value < BEATS_PER_MINUTE_PRESTISSIMO) then
    listSpeed.selectedItem = 6
  else if (value >= BEATS_PER_MINUTE_PRESTISSIMO) then
    listSpeed.selectedItem = 7
  end if
  beats_per_minute = value
  metronome_init()
end sub

sub listMeasure_changed(self as list, index as integer)
  select case index
    case 1
      beats_per_measure = 3
      divisions_per_beat = 4
    case 2
      beats_per_measure = 4
      divisions_per_beat = 4
    case 3
      beats_per_measure = 3
      divisions_per_beat = 8
    case 4
      beats_per_measure = 4
      divisions_per_beat = 8
    case 5
      beats_per_measure = 8
      divisions_per_beat = 8
    case 6
      beats_per_measure = 8
      divisions_per_beat = 16
  end select
  numberMeasure1.value = beats_per_measure
  numberMeasure2.value = divisions_per_beat
  metronome_init()
  gadgetMetronome_draw(gadgetMetronome)
end sub

sub numberMeasure1_changed(self as number, value as integer)
  if (value = 3 and divisions_per_beat = 4) then
    listMeasure.selectedItem = 1
  else if (value = 3 and divisions_per_beat = 8) then
      listMeasure.selectedItem = 3
  else if (value = 4 and divisions_per_beat = 4) then
    listMeasure.selectedItem = 2
  else if (value = 4 and divisions_per_beat = 8) then
      listMeasure.selectedItem = 4
  else if (value = 8 and divisions_per_beat = 8) then
    listMeasure.selectedItem = 5
  else if (value = 8 and divisions_per_beat = 16) then
    listMeasure.selectedItem = 6
  else
    listMeasure.selectedItem = 0
  end if
  beats_per_measure = value
  metronome_init()
  gadgetMetronome_draw(gadgetMetronome)
end sub

sub numberMeasure2_changed(self as number, value as integer)
  if (value = 4 and beats_per_measure = 3) then
    listMeasure.selectedItem = 1
  else if (value = 4 and beats_per_measure = 4) then
      listMeasure.selectedItem = 2
  else if (value = 8 and beats_per_measure = 3) then
    listMeasure.selectedItem = 3
  else if (value = 8 and beats_per_measure = 4) then
      listMeasure.selectedItem = 4
  else if (value = 8 and beats_per_measure = 8) then
    listMeasure.selectedItem = 5
  else if (value = 16 and beats_per_measure = 8) then
    listMeasure.selectedItem = 6
  else
    listMeasure.selectedItem = 0
  end if
  divisions_per_beat = value
  metronome_init()
  gadgetMetronome_draw(gadgetMetronome)
end sub

sub timerMetronome_ring(self as timer)
  if (timer_tick_of_division = 0) then
    gadgetMetronome_drawDigitalIndicator(gadgetMetronome)
    if (division_of_beat = 0) then
      gadgetMetronome_drawDigitalIndicator(gadgetMetronome)
      soundMetronome.StandardSound(SS_KEY_CLICK)
      if (beat_of_measure = 0) then
        gadgetMetronome_drawMeasureCounter(gadgetMetronome)
      end if
    end if
  end if

  timer_tick_of_division = timer_tick_of_division + 1

  if (timer_tick_of_division >= timer_ticks_per_division) then
    timer_tick_of_division = 0
    division_of_beat = division_of_beat + 1
    if (division_of_beat >= divisions_per_beat) then
      division_of_beat = 0
      beat_of_measure = beat_of_measure + 1
      if (beat_of_measure >= beats_per_measure) then
        beat_of_measure = 0
        measure_count = measure_count + 1
      end if
    end if
  end if
end sub

